<template>
  <Login v-if="!settings.refreshToken" />
  <template v-if="settings.refreshToken">
    <TopBar />
    <SideBar />
    <MobileSideBar />
    <router-view />
  </template>
  <p-Toast position="bottom-right" />
</template>

<script lang="ts" setup>
import {
  Message,
  messages,
  Now,
  settings,
  Resources,
  WeekPlanning,
  roleManager,
} from '@/states'
import { provide, watchEffect } from 'vue'
import Login from '@/components/Login.vue'
import TopBar from '@/components/bars/TopBar.vue'
import SideBar from '@/components/bars/SideBar.vue'
import MobileSideBar from '@/components/bars/MobileSideBar.vue'
import { useToast } from 'primevue/usetoast'
import {
  NowKey,
  ResourcesKey,
  RoleManagerKey,
  SettingsKey,
  WeekPlanningKey,
} from '@/provided'

watchEffect(() => {
  while (messages.value.length) toast.add(messages.value.shift() as Message)
})

const toast = useToast()

provide(RoleManagerKey, roleManager)
provide(SettingsKey, settings)
provide(NowKey, Now)
provide(ResourcesKey, Resources)
provide(WeekPlanningKey, WeekPlanning)

let active = 'notLoaded'
watchEffect(() => {
  if (active === settings.theme) return
  if (active === 'notLoaded') {
    switch (settings.theme) {
      case 'themeDark':
        import('./style/darkTheme')
        break
      default:
        import('./style/lightTheme')
    }
    active = settings.theme
    return
  }
  // If theme has already been loaded and need to be changed, let's reload the app
  window.location.reload()
})
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use 'src/style/mixins' as m;

.SideBar {
  @include m.mobile {
    display: none;
  }

  grid-area: sideBar;
}
</style>
